data:extend(
{
  {
    type = "item",
    name = "steel-furnace2",
    icon = "__base__/graphics/icons/steel-furnace.png",
    flags = {"goes-to-quickbar"},
    subgroup = "smelting-machine",
    order = "b[steel-furnace2]",
    place_result = "steel-furnace2",
    stack_size = 50
  },
  {
    type = "item",
    name = "silicon",
    icon = "__vanillaplus__/graphics/icons/silicon.png",
    flags = {"goes-to-quickbar"},
    subgroup = "raw-material",
    order = "d[steel-plate]-b",
    stack_size = 50
  },
  {
    type = "item",
    name = "improved-mining-drill",
    icon = "__vanillaplus__/graphics/icons/improved-mining-drill.png",
    flags = {"goes-to-quickbar"},
    subgroup = "extraction-machine",
    order = "a[items]-b[improved-mining-drill]",
    place_result = "improved-mining-drill",
    stack_size = 50
  },
  {
    type = "item",
    name = "advanced-mining-drill",
    icon = "__vanillaplus__/graphics/icons/advanced-mining-drill.png",
    flags = {"goes-to-quickbar"},
    subgroup = "extraction-machine",
    order = "a[items]-c[advanced-mining-drill]",
    place_result = "advanced-mining-drill",
    stack_size = 50
  },
  {
    type = "item",
    name = "improved-boiler",
    icon = "__vanillaplus__/graphics/icons/improved-boiler.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]-b",
    place_result = "improved-boiler",
    stack_size = 50
  },
  {
    type = "item",
    name = "advanced-boiler",
    icon = "__vanillaplus__/graphics/icons/advanced-boiler.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]-c",
    place_result = "advanced-boiler",
    stack_size = 50
  },
  {
    type = "item",
    name = "advanced-steam-engine",
    icon = "__vanillaplus__/graphics/icons/advanced-steam-engine.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "b[steam-power]-c[advanced-steam-engine]",
    place_result = "advanced-steam-engine",
    stack_size = 10
  },
  {
    type = "item",
    name = "advanced-oil-refinery",
    icon = "__vanillaplus__/graphics/icons/advanced-oil-refinery.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "d[refinery]-b",
    place_result = "advanced-oil-refinery",
    stack_size = 10
  },
  {
    type = "item",
    name = "advanced-chemical-plant",
    icon = "__vanillaplus__/graphics/icons/advanced-chemical-plant.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "e[chemical-plant]-b",
    place_result = "advanced-chemical-plant",
    stack_size = 10
  },
  {
    type = "item",
    name = "assembling-machine-4",
    icon = "__vanillaplus__/graphics/icons/advanced-assembling-machine.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "c[assembling-machine-3]-b",
    place_result = "assembling-machine-4",
    stack_size = 50
  },
  {
    type = "gun",
    name = "assault-rifle",
    icon = "__vanillaplus__/graphics/icons/assault-rifle.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "gun",
    order = "a[basic-clips]-b[submachine-gun]-b",
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "bullet",
      cooldown = 10,
	  damage_modifier = 2.5,
      movement_slow_down_factor = 0.5,
      shell_particle =
      {
        name = "shell-particle",
        direction_deviation = 0.1,
        speed = 0.1,
        speed_deviation = 0.03,
        center = {0, 0.1},
        creation_distance = -0.5,
        starting_frame_speed = 0.4,
        starting_frame_speed_deviation = 0.1
      },
      projectile_creation_distance = 1.125,
      range = 18,
      sound = make_heavy_gunshot_sounds(),
    },
    stack_size = 1
  },
  {
    type = "item",
    name = "concrete-wall",
    icon = "__vanillaplus__/graphics/icons/concrete-wall.png",
    flags = {"goes-to-quickbar"},
    subgroup = "defensive-structure",
    order = "a[stone-wall]-a[stone-wall]-b",
    place_result = "concrete-wall",
    stack_size = 50
  },
  {
    type = "module",
    name = "pollution-module",
    icon = "__vanillaplus__/graphics/icons/pollution-module.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "module",
    order = "a[pollution]-a[pollution-module-1]",
    stack_size = 50,
    default_request_amount = 10,
    effect = {pollution = {bonus = -0.35}, consumption = {bonus = 0.35}}
  },
  {
    type = "module",
    name = "pollution-module-2",
    icon = "__vanillaplus__/graphics/icons/pollution-module-2.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "module",
    order = "a[pollution]-b[pollution-module-2]",
    stack_size = 50,
    default_request_amount = 10,
    effect = {pollution = {bonus = -0.60}, consumption = {bonus = 0.6}}
  },
  {
    type = "module",
    name = "pollution-module-3",
    icon = "__vanillaplus__/graphics/icons/pollution-module-3.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "module",
    order = "a[pollution]-c[pollution-module-3]",
    stack_size = 50,
    default_request_amount = 10,
    effect = {pollution = {bonus = -0.8}, consumption = {bonus = 0.8}}
  }
})