data:extend(
{
  {
    type = "technology",
    name = "improved-mining-drill",
    icon = "__vanillaplus__/graphics/technology/improved-mining-drill.png",
    prerequisites = {"steel-processing", "advanced-electronics"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "improved-mining-drill"
      },
    },
    unit =
    {
      count = 100,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}},
      time = 30
    },
    order = "a-k-a"
  },
--------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "advanced-mining-drill",
    icon = "__vanillaplus__/graphics/technology/advanced-mining-drill.png",
    prerequisites = {"improved-mining-drill"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "advanced-mining-drill"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}},
      time = 45
    },
    order = "a-l-a"
  },
--------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "improved-boiler",
    icon = "__vanillaplus__/graphics/technology/improved-boiler.png",
    prerequisites = {"advanced-electronics", "advanced-material-processing"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "improved-boiler"
      },
    },
    unit =
    {
      count = 100,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}},
      time = 30
    },
    order = "a-l-a"
  },
--------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "advanced-boiler",
    icon = "__vanillaplus__/graphics/technology/advanced-boiler.png",
    prerequisites = {"improved-boiler"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "advanced-boiler"
      },
    },
    unit =
    {
      count = 200,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}},
      time = 60
    },
    order = "a-l-a"
  },
--------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "advanced-steam-engine",
    icon = "__vanillaplus__/graphics/technology/advanced-steam-engine.png",
    prerequisites = {"advanced-electronics", "advanced-material-processing"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "advanced-steam-engine"
      },
    },
    unit =
    {
      count = 100,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}},
      time = 30
    },
    order = "a-l-a"
  },
------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "advanced-oil-processing2",
    icon = "__vanillaplus__/graphics/technology/advanced-oil-processing.png",
    prerequisites = {"advanced-oil-processing"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "advanced-oil-refinery"
      },
      {
        type = "unlock-recipe",
        recipe = "advanced-chemical-plant"
      }
    },
    unit =
    {
      count = 100,
      ingredients = {{"science-pack-1", 2},
                     {"science-pack-2", 2},
                     {"science-pack-3", 1}},
      time = 60
    },
    order = "d-b-b",
	icon_size = "128"
  },
------------------------------------------------------------------------------------------
  {
    type = "technology",
    name = "advanced-automation",
    icon = "__vanillaplus__/graphics/technology/automation.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-4"
      }
    },
    prerequisites = {"automation-3"},
    unit =
    {
      count = 200,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}},
      time = 60
    },
    order = "a-b-c",
	icon_size = "128"
  },
------------------------------------------------------------------------
  {
    type = "technology",
    name = "pollution-module",
    icon = "__vanillaplus__/graphics/technology/pollution-module.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "pollution-module"
      }
    },
    prerequisites = {"modules"},
    unit =
    {
      count = 50,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
      },
      time = 30
    },
    upgrade = true,
    order = "i-c-a",
	icon_size = "128"
  },
  {
    type = "technology",
    name = "pollution-module-2",
    icon = "__vanillaplus__/graphics/technology/pollution-module.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "pollution-module-2"
      }
    },
    prerequisites = {"pollution-module"},
    unit =
    {
      count = 75,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
      },
      time = 30
    },
    upgrade = true,
    order = "i-c-b",
	icon_size = "128"
  },
  {
    type = "technology",
    name = "pollution-module-3",
    icon = "__vanillaplus__/graphics/technology/pollution-module.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "pollution-module-3"
      }
    },
    prerequisites = {"pollution-module-2"},
    unit =
    {
      count = 300,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 60
    },
    upgrade = true,
    order = "i-c-c",
	icon_size = "128"
  },
  {
    type = "technology",
    name = "military-5",
    icon = "__base__/graphics/technology/military.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "railgun"
      },
	  {
        type = "unlock-recipe",
        recipe = "railgun-dart"
      }
    },
    prerequisites = {"military-4"},
    unit =
    {
      count = 200,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 2},
        {"science-pack-3", 1},
        {"alien-science-pack", 1},
      },
      time = 60
    },
    order = "e-a-d"
  }
})